fs = require 'fs'
Producer = require "../ProducerClass"
child_process = require 'child_process'
debug = require("debug")("omg-numberlist")
async = require 'async'

unless fs.existsSync "/data/numberlists/"
  fs.mkdirSync "/data/numberlists/"

validateFilename = (filename) ->
  filename = filename.replace /\/|\"|\\|/ |/./g, ""
  filename = "#{filename}.lst"

class Numberlist extends Producer
  isRunning = false
  constructor: ->
    super "numberlist"

    readNumberList = (filename, cb) ->
      child_process.exec "blwl t /data/#{filename}", (error, stdout, stderr) ->
        if stdout
          stdout = stdout.toString()
          debug "read #{filename}: #{stdout}"
          cb null, {name: filename.replace(".lst", ""), numbers: stdout}
        else
          debug "list #{filename} could not be read"
          cb error or stderr or "error"


    @getListNames = (callback) =>
      fs.readdir "/data/numberlists", (err, res) =>
        if res and res.length
          debug "found numberlists: #{res}"
          async.map res, readNumberList, (err, lists) =>
            debug "lists with numbers: #{JSON.stringify(lists)}"
            @replyData {lists: lists}, callback
        else
          debug "no numberlists present"
          @replyData "empty", callback

    @delete = (filename, callback) =>
      filename = validateFilename filename
      debug "deleting #{filename}"
      fs.unlink "/data/#{filename}", (err) =>
        if err
          err1 = err
        fs.unlink "/data/numberlists/#{filename}", (err) =>
          unless err or err1
            @replyData "#{filename} deleted", callback
          if err or err1
            @replyError err or err1, callback

    @set = (numbersObject, callback) =>
      debug "received request to store #{numbersObject}"
      try
        numbersObject = JSON.parse(numbersObject)
      if numbersObject
        debug "storing #{numbersObject.filename}"
        debug "storing #{numbersObject.numbers}"
        if numbersObject.filename
          filename = validateFilename(numbersObject.filename)

        numbersObject.numbers = (num for num in numbersObject.numbers when num)
        if numbersObject.numbers and numbersObject.numbers[0]
          nums = numbersObject.numbers.join "\n"
          debug "numbers to be stored in #{filename}: #{nums}"

        if nums and filename
          fs.writeFile "/data/numberlists/#{filename}", nums, (err, res) =>
            if err
              @replyError "could not write file 1", callback
              return
            #else
            child_process.exec "blwl c /data/numberlists/#{filename} /data/#{filename}", (error, stdout, stderr) =>
              console.log error if error
              console.log stderr if stderr
              console.log stdout if stdout
              if error or stderr
                @replyError error or stderr, callback
              else
                readNumberList filename, (err, list) =>
                  @replyData list or "error", callback

                return
                child_process.exec "blwl t /data/#{filename}", (error, stdout, stderr) =>
                  if stdout
                    stdout = stdout.toString()
                  @replyData stdout or "error", callback
        else
          @replyError "could not write file. Numbers or file name invalid", callback

      else
        @replyError "No numbers or no file name specified", callback

  check: (numbersObject, callback) =>
    filename = validateFilename numbersObject.filename
    command = "blwl f /data/#{filename} #{numbersObject.numberToCheck}"
    debug command
    child_process.exec command, (error, stdout, stderr) =>
      console.log error if error
      console.log stderr if stderr
      console.log stdout if stdout
      if stdout
        stdout = stdout.toString()
        stdout = stdout.replace /\n|[a-z]|\=/g, ""
        @replyData stdout, callback
      else
        @replyError "err", callback

module.exports = new Numberlist()