###
* omg-uptime
*
* Copyright (c) 2015 Ferrari electronic AG
###

'use strict'
os = require "os"
exec = require "child_process"
  .exec

async = require "async"

debug = require("debug")("omg-uptime")

Producer = require "../../ProducerClass"

class Uptime extends Producer
  isRunning = false
  constructor: ->
    super "uptime",10 * 1000

    getcpus = (asyncCallback) ->
      cpus = os.cpus().length
      asyncCallback null, cpus

    getUptime = (asyncCallback) ->
      totalSec = os.uptime()
      hours = parseInt( totalSec / 3600, 10) % 24
      minutes = parseInt( totalSec / 60, 10 ) % 60
      seconds = parseInt( totalSec % 60, 10)

      result = if hours < 10 then "0#{hours}" else hours
      result = result + ":"
      result = result + if minutes < 10 then "0#{minutes}" else minutes
      result = result + ":"
      result = result + if seconds < 10 then "0#{seconds}" else seconds

      asyncCallback null, result

    gettime = (asyncCallback) ->
      time = ((new Date()).toTimeString()).substring(0,8)
      asyncCallback null, time

    getloadavg = (asyncCallback) ->
      load = (load.toFixed(2) for load in os.loadavg())
      asyncCallback null, load

    getusers = (asyncCallback) ->
      exec "users", (err, stdout) ->
        users = stdout.split(" ").length
        asyncCallback null, users

    getNewData = false
    run = =>

      returnObject = {}

      toRunInParallel =
        cpus: getcpus
        uptime: getUptime
        time: gettime
        loadavg: getloadavg
        users: getusers

      async.parallel toRunInParallel, (err, results) =>
        @sendData results

    run()

    @start = =>
      @debug "starting"
      #run directly
      run()
      clearInterval getNewData if getNewData
      getNewData = setInterval run, 2 * 1000


    @stop = =>
      clearInterval getNewData if getNewData
      isRunning = false

  subscribe: =>
    unless isRunning
      isRunning = true
      @start()
    super

module.exports = new Uptime()

return

returnObject = {}
returnObject.cpus = os.cpus().length

exports.start = (callback) ->

  totalSec = os.uptime()
  hours = parseInt( totalSec / 3600, 10) % 24
  minutes = parseInt( totalSec / 60, 10 ) % 60
  seconds = parseInt( totalSec % 60, 10)

  result = if hours < 10 then "0#{hours}" else hours
  result = result + ":"
  result = result + if minutes < 10 then "0#{minutes}" else minutes
  result = result + ":"
  result = result + if seconds < 10 then "0#{seconds}" else seconds


  returnObject.uptime= result

  returnObject.time = ((new Date()).toTimeString()).substring(0,8)
  returnObject.loadavg = (load.toFixed(2) for load in os.loadavg())

  exec("users", (err, stdout) ->
    returnObject.users = stdout.split(" ").length
    callback null, returnObject
    )
